---
title: PointerEvent
slug: Web/API/PointerEvent
tags:
  - API
  - DOM
  - Interface
  - Pointer Events
  - PointerEvent
  - Reference
  - events
---
<p>{{ APIRef("Pointer Events") }}</p>

<p>The <strong><code>PointerEvent</code></strong> interface represents the state of a DOM event produced by a pointer such as the geometry of the contact point, the device type that generated the event, the amount of pressure that was applied on the contact surface, etc.</p>

<p>A <em>pointer</em> is a hardware agnostic representation of input devices (such as a mouse, pen or contact point on a touch-enable surface). The pointer can target a specific coordinate (or set of coordinates) on the contact surface such as a screen.</p>

<p>A pointer's <em>hit test</em> is the process a browser uses to determine the target element for a pointer event. Typically, this is determined by considering the pointer's location and also the visual layout of elements in a document on screen media.</p>

<h2 id="Constructors">Constructors</h2>

<dl>
 <dt>{{domxref("PointerEvent.PointerEvent", "PointerEvent()")}}</dt>
 <dd>Creates a synthetic—and untrusted—<code>PointerEvent</code>.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface inherits properties from {{domxref("MouseEvent")}} and {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{ domxref('PointerEvent.pointerId')}} {{readonlyInline}}</dt>
 <dd>A unique identifier for the pointer causing the event.</dd>
 <dt>{{ domxref('PointerEvent.width')}} {{readonlyInline}}</dt>
 <dd>The width (magnitude on the X axis), in CSS pixels, of the contact geometry of the pointer.</dd>
 <dt>{{ domxref('PointerEvent.height')}} {{readonlyInline}}</dt>
 <dd>The height (magnitude on the Y axis), in CSS pixels, of the contact geometry of the pointer.</dd>
 <dt>{{ domxref('PointerEvent.pressure')}} {{readonlyInline}}</dt>
 <dd>The normalized pressure of the pointer input in the range <code>0</code> to <code>1</code>, where <code>0</code> and <code>1</code> represent the minimum and maximum pressure the hardware is capable of detecting, respectively.</dd>
 <dt>{{ domxref('PointerEvent.tangentialPressure')}} {{readonlyInline}}</dt>
 <dd>The normalized tangential pressure of the pointer input (also known as barrel pressure or <a href="https://en.wikipedia.org/wiki/Cylinder_stress">cylinder stress</a>) in the range <code>-1</code> to <code>1</code>, where <code>0</code> is the neutral position of the control.</dd>
 <dt>{{ domxref('PointerEvent.tiltX')}} {{readonlyInline}}</dt>
 <dd>The plane angle (in degrees, in the range of <code>-90</code> to <code>90</code>) between the Y–Z plane and the plane containing both the pointer (e.g. pen stylus) axis and the Y axis.</dd>
 <dt>{{ domxref('PointerEvent.tiltY')}} {{readonlyInline}}</dt>
 <dd>The plane angle (in degrees, in the range of <code>-90</code> to <code>90</code>) between the X–Z plane and the plane containing both the pointer (e.g. pen stylus) axis and the X axis.</dd>
 <dt>{{ domxref('PointerEvent.twist')}} {{readonlyInline}}</dt>
 <dd>The clockwise rotation of the pointer (e.g. pen stylus) around its major axis in degrees, with a value in the range <code>0</code> to <code>359</code>.</dd>
 <dt>{{ domxref('PointerEvent.pointerType')}} {{readonlyInline}}</dt>
 <dd>Indicates the device type that caused the event (mouse, pen, touch, etc.)</dd>
 <dt>{{ domxref('PointerEvent.isPrimary')}} {{readonlyInline}}</dt>
 <dd>Indicates if the pointer represents the primary pointer of this pointer type.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{DOMxRef('PointerEvent.getCoalescedEvents()')}} {{Experimental_Inline}}</dt>
 <dd>Returns a sequence of all <code>PointerEvent</code> instances that were coalesced into the dispatched {{event("pointermove")}} event.</dd>
 <dt>{{DOMxRef('PointerEvent.getPredictedEvents()')}} {{Experimental_Inline}}</dt>
 <dd>Returns a sequence of <code>PointerEvent</code> instances that the browser predicts will follow the dispatched {{event("pointermove")}} event's coalesced events.</dd>
</dl>

<h2 id="Pointer_event_types">Pointer event types</h2>

<p>The <code>PointerEvent</code> interface has several event types. To determine which event fired, look at the event's {{ domxref("Event.type", "type") }} property.</p>

<div class="note"><strong>Note:</strong> It's important to note that in many cases, both pointer and mouse events get sent (in order to let non-pointer-specific code still interact with the user). If you use pointer events, you should call {{ domxref("event.preventDefault()") }} to keep the mouse event from being sent as well.</div>

<dl>
 <dt>{{event('pointerover')}}</dt>
 <dd>This event is fired when a pointing device is moved into an element's hit test boundaries.</dd>
 <dt>{{event('pointerenter')}}</dt>
 <dd>This event is fired when a pointing device is moved into the hit test boundaries of an element or one of its descendants, including as a result of a pointerdown event from a device that does not support hover (see pointerdown). This event type is similar to <code>pointerover</code>, but differs in that it does not bubble.</dd>
 <dt>{{event('pointerdown')}}</dt>
 <dd>The event is fired when a pointer becomes <em>active</em>. For mouse, it is fired when the device transitions from no buttons depressed to at least one button depressed. For touch, it is fired when physical contact is made with the digitizer. For pen, it is fired when the stylus makes physical contact with the digitizer.</dd>
 <dt>{{event('pointermove')}}</dt>
 <dd>This event is fired when a pointer changes coordinates.</dd>
 <dt>{{event('pointerrawupdate')}} {{Experimental_Inline}}</dt>
 <dd>This event is fired when any of a pointer's properties change.</dd>
 <dt>{{event('pointerup')}}</dt>
 <dd>This event is fired when a pointer is no longer <em>active</em>.</dd>
 <dt>{{event('pointercancel')}}</dt>
 <dd>A browser fires this event if it concludes the pointer will no longer be able to generate events (for example the related device is deactived).</dd>
 <dt>{{event('pointerout')}}</dt>
 <dd>This event is fired for several reasons including: pointing device is moved out of the hit test boundaries of an element; firing the <code>pointerup</code> event for a device that does not support hover (see <code>pointerup</code>); after firing the <code>pointercancel</code> event (see <code>pointercancel</code>); when a pen stylus leaves the hover range detectable by the digitizer.</dd>
 <dt>{{event('pointerleave')}}</dt>
 <dd>This event is fired when a pointing device is moved out of the hit test boundaries of an element. For pen devices, this event is fired when the stylus leaves the hover range detectable by the digitizer.</dd>
 <dt>{{event('gotpointercapture')}}</dt>
 <dd>This event is fired when an element receives pointer capture.</dd>
 <dt>{{event('lostpointercapture')}}</dt>
 <dd>This event is fired after pointer capture is released for a pointer.</dd>
</dl>

<h2 id="GlobalEventHandlers">GlobalEventHandlers</h2>

<dl>
 <dt>{{ domxref('GlobalEventHandlers.onpointerover') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointerover')}} event.</dd>
 <dt>{{ domxref('GlobalEventHandlers.onpointerenter') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointerenter')}} event.</dd>
 <dt>{{ domxref('GlobalEventHandlers.onpointerdown') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointerdown')}} event.</dd>
 <dt>{{ domxref('GlobalEventHandlers.onpointermove') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointermove')}} event.</dd>
 <dt>{{ domxref('GlobalEventHandlers.onpointerup') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointerup')}} event.</dd>
 <dt>{{ domxref('GlobalEventHandlers.onpointercancel') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointercancel')}} event.</dd>
 <dt>{{ domxref('GlobalEventHandlers.onpointerout') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointerout')}} event.</dd>
 <dt>{{ domxref('GlobalEventHandlers.onpointerleave') }}</dt>
 <dd>A {{domxref('GlobalEventHandlers','global event handler')}} for the {{event('pointerleave')}} event.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>Examples of each property, event type, and global event handler are included in their respective reference pages.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Pointer Events 3','#pointerevent-interface', 'PointerEvent')}}</td>
   <td>{{Spec2('Pointer Events 3')}}</td>
   <td>Added the {{DOMxRef('PointerEvent.getCoalescedEvents()', 'getCoalescedEvents()')}} and {{DOMxRef('PointerEvent.getPredictedEvents()', 'getPredictedEvents()')}} methods and {{Event('pointerrawupdate')}} event.</td>
  </tr>
  <tr>
   <td>{{SpecName('Pointer Events 2','#pointerevent-interface', 'PointerEvent')}}</td>
   <td>{{Spec2('Pointer Events 2')}}</td>
   <td>Added the {{DOMxRef('PointerEvent.twist', 'twist')}} and {{DOMxRef('PointerEvent.tangentialPressure', 'tangentialPressure')}} properties.</td>
  </tr>
  <tr>
   <td>{{SpecName('Pointer Events', '#pointerevent-interface', 'PointerEvent')}}</td>
   <td>{{Spec2('Pointer Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PointerEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{ domxref("Touch_events","Touch Events") }}</li>
 <li>{{ domxref("GestureEvent") }}</li>
 <li>{{ domxref("MSGestureEvent") }}</li>
 <li>{{cssxref("touch-action")}}</li>
</ul>
